#!/usr/bin/env python
# vim: set fileencoding=utf-8 :

###############################################################################
#                                                                             #
# Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/           #
# Contact: beat.support@idiap.ch                                              #
#                                                                             #
# This file is part of the beat.web module of the BEAT platform.              #
#                                                                             #
# Commercial License Usage                                                    #
# Licensees holding valid commercial BEAT licenses may use this file in       #
# accordance with the terms contained in a written agreement between you      #
# and Idiap. For further information contact tto@idiap.ch                     #
#                                                                             #
# Alternatively, this file may be used under the terms of the GNU Affero      #
# Public License version 3 as published by the Free Software and appearing    #
# in the file LICENSE.AGPL included in the packaging of this file.            #
# The BEAT platform is distributed in the hope that it will be useful, but    #
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  #
# or FITNESS FOR A PARTICULAR PURPOSE.                                        #
#                                                                             #
# You should have received a copy of the GNU Affero Public License along      #
# with the BEAT platform. If not, see http://www.gnu.org/licenses/.           #
#                                                                             #
###############################################################################

from __future__ import unicode_literals

from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ('dataformats', '0001_initial'),
        ('algorithms', '0001_initial'),
        ('toolchains', '0001_initial'),
        ('experiments', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='Attestation',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('number', models.IntegerField()),
                ('locked', models.BooleanField(default=True)),
                ('creation_date', models.DateTimeField()),
                ('publication_date', models.DateTimeField(null=True, blank=True)),
                ('expiration_date', models.DateTimeField(null=True, blank=True)),
                ('algorithms', models.ManyToManyField(related_name='attestations', to='algorithms.Algorithm', blank=True)),
                ('dataformats', models.ManyToManyField(related_name='attestations', to='dataformats.DataFormat', blank=True)),
                ('experiment', models.OneToOneField(related_name='attestation', to='experiments.Experiment')),
                ('toolchain', models.ForeignKey(related_name='attestations', blank=True, to='toolchains.Toolchain', null=True)),
            ],
        ),
    ]
