#!/usr/bin/env python
# vim: set fileencoding=utf-8 :

###############################################################################
#                                                                             #
# Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/           #
# Contact: beat.support@idiap.ch                                              #
#                                                                             #
# This file is part of the beat.web module of the BEAT platform.              #
#                                                                             #
# Commercial License Usage                                                    #
# Licensees holding valid commercial BEAT licenses may use this file in       #
# accordance with the terms contained in a written agreement between you      #
# and Idiap. For further information contact tto@idiap.ch                     #
#                                                                             #
# Alternatively, this file may be used under the terms of the GNU Affero      #
# Public License version 3 as published by the Free Software and appearing    #
# in the file LICENSE.AGPL included in the packaging of this file.            #
# The BEAT platform is distributed in the hope that it will be useful, but    #
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  #
# or FITNESS FOR A PARTICULAR PURPOSE.                                        #
#                                                                             #
# You should have received a copy of the GNU Affero Public License along      #
# with the BEAT platform. If not, see http://www.gnu.org/licenses/.           #
#                                                                             #
###############################################################################

from ..common.serializers import DynamicFieldsSerializer, ContributionSerializer
from .models import Plotter, PlotterParameter, DefaultPlotter
from rest_framework import serializers

class PlotterSerializer(ContributionSerializer):

    dataformat = serializers.CharField(source="dataformat.fullname")

    class Meta(ContributionSerializer.Meta):
        model = Plotter
        default_fields = [
                'name', 'dataformat',
                ]

class PlotterParameterSerializer(ContributionSerializer):

    class Meta(ContributionSerializer.Meta):
        model = PlotterParameter
        exclude = []
        default_fields = [
                'name',
                ]

class DefaultPlotterSerializer(DynamicFieldsSerializer):

    dataformat = serializers.CharField(source="dataformat.fullname")
    plotter    = serializers.CharField(source="plotter.fullname")
    parameter  = serializers.CharField(source="parameter.fullname")

    class Meta(DynamicFieldsSerializer.Meta):
        model = DefaultPlotter
        default_fields = [
                'dataformat', 'plotter', 'parameter',
                ]
