#!/usr/bin/env python
# vim: set fileencoding=utf-8 :

###############################################################################
#                                                                             #
# Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/           #
# Contact: beat.support@idiap.ch                                              #
#                                                                             #
# This file is part of the beat.web module of the BEAT platform.              #
#                                                                             #
# Commercial License Usage                                                    #
# Licensees holding valid commercial BEAT licenses may use this file in       #
# accordance with the terms contained in a written agreement between you      #
# and Idiap. For further information contact tto@idiap.ch                     #
#                                                                             #
# Alternatively, this file may be used under the terms of the GNU Affero      #
# Public License version 3 as published by the Free Software and appearing    #
# in the file LICENSE.AGPL included in the packaging of this file.            #
# The BEAT platform is distributed in the hope that it will be useful, but    #
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  #
# or FITNESS FOR A PARTICULAR PURPOSE.                                        #
#                                                                             #
# You should have received a copy of the GNU Affero Public License along      #
# with the BEAT platform. If not, see http://www.gnu.org/licenses/.           #
#                                                                             #
###############################################################################

from django.conf.urls import *
from . import api


urlpatterns = [
    url(
        r'^$',
        api.ReportListView.as_view(),
        name='all'
    ),

    url(
        r'^(?P<number>\d+)/$',
        api.ReportDetailView.as_view(),
        name='object_report'
    ),

    url(
        r'^(?P<number>\d+)/results/$',
        api.ReportResultsView.as_view(),
        name='results'
    ),

    url(
        r'^(?P<owner_name>\w+)/(?P<report_name>[\w\W]+)/results_author/$',
        api.ReportResultsAllExperimentsView.as_view(),
        name='results'
    ),

    url(
        r'^(?P<owner_name>\w+)/$',
        api.UserReportListView.as_view(),
        name='list_create'
    ),

    url(
        r'^(?P<owner_name>\w+)/(?P<report_name>[\w\W]+)/add/$',
        api.ReportAddExperimentsView.as_view(),
        name='add_experiments'
    ),

    url(
        r'^(?P<owner_name>\w+)/(?P<report_name>[\w\W]+)/remove/$',
        api.ReportRemoveExperimentsView.as_view(),
        name='remove_experiments'
    ),

    url(
        r'^(?P<owner_name>\w+)/(?P<report_name>[\w\W]+)/lock/$',
        api.LockReportView.as_view(),
        name='lock'
    ),

    url(
        r'^(?P<owner_name>\w+)/(?P<report_name>[\w\W]+)/publish/$',
        api.PublishReportView.as_view(),
        name='publish'
    ),

    url(
        r'^(?P<owner_name>\w+)/(?P<report_name>[\w\W]+)/algorithms/$',
        api.ReportAlgorithmsView.as_view(),
        name='algorithms'
    ),

    url(
        r'^(?P<owner_name>\w+)/(?P<report_name>[\w\W]+)/$',
        api.ReportDetailView.as_view(),
        name='object'
    ),
]
