#!/usr/bin/env python
# vim: set fileencoding=utf-8 :

###############################################################################
#                                                                             #
# Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/           #
# Contact: beat.support@idiap.ch                                              #
#                                                                             #
# This file is part of the beat.web module of the BEAT platform.              #
#                                                                             #
# Commercial License Usage                                                    #
# Licensees holding valid commercial BEAT licenses may use this file in       #
# accordance with the terms contained in a written agreement between you      #
# and Idiap. For further information contact tto@idiap.ch                     #
#                                                                             #
# Alternatively, this file may be used under the terms of the GNU Affero      #
# Public License version 3 as published by the Free Software and appearing    #
# in the file LICENSE.AGPL included in the packaging of this file.            #
# The BEAT platform is distributed in the hope that it will be useful, but    #
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  #
# or FITNESS FOR A PARTICULAR PURPOSE.                                        #
#                                                                             #
# You should have received a copy of the GNU Affero Public License along      #
# with the BEAT platform. If not, see http://www.gnu.org/licenses/.           #
#                                                                             #
###############################################################################

from __future__ import unicode_literals

from django.db import migrations, models
from django.conf import settings


class Migration(migrations.Migration):

    dependencies = [
        ('experiments', '0001_initial'),
        ('algorithms', '0001_initial'),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('plotters', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='Report',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('status', models.CharField(default=b'E', max_length=1, choices=[(b'E', b'Editable'), (b'L', b'Locked'), (b'P', b'Published')])),
                ('name', models.CharField(help_text=b'The name for this object (space-like characters will be automatically replaced by dashes)', max_length=200)),
                ('number', models.IntegerField(blank=True)),
                ('creation_date', models.DateTimeField()),
                ('publication_date', models.DateTimeField(null=True, blank=True)),
                ('short_description', models.CharField(default=b'', help_text=b'Describe the object succinctly (try to keep it under 80 characters)', max_length=100, blank=True)),
                ('description', models.TextField(default=b'', blank=True)),
                ('content', models.TextField(default=b'{}', blank=True)),
                ('analyzer', models.ForeignKey(related_name='reports', blank=True, to='algorithms.Algorithm', null=True)),
                ('author', models.ForeignKey(related_name='reports', to=settings.AUTH_USER_MODEL)),
                ('experiments', models.ManyToManyField(related_name='reports', to='experiments.Experiment', blank=True)),
                ('referenced_plotterparameters', models.ManyToManyField(related_name='reports', to='plotters.PlotterParameter', blank=True)),
                ('referenced_plotters', models.ManyToManyField(related_name='reports', to='plotters.Plotter', blank=True)),
            ],
        ),
    ]
