#!/usr/bin/env python
# vim: set fileencoding=utf-8 :

###############################################################################
#                                                                             #
# Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/           #
# Contact: beat.support@idiap.ch                                              #
#                                                                             #
# This file is part of the beat.web module of the BEAT platform.              #
#                                                                             #
# Commercial License Usage                                                    #
# Licensees holding valid commercial BEAT licenses may use this file in       #
# accordance with the terms contained in a written agreement between you      #
# and Idiap. For further information contact tto@idiap.ch                     #
#                                                                             #
# Alternatively, this file may be used under the terms of the GNU Affero      #
# Public License version 3 as published by the Free Software and appearing    #
# in the file LICENSE.AGPL included in the packaging of this file.            #
# The BEAT platform is distributed in the hope that it will be useful, but    #
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  #
# or FITNESS FOR A PARTICULAR PURPOSE.                                        #
#                                                                             #
# You should have received a copy of the GNU Affero Public License along      #
# with the BEAT platform. If not, see http://www.gnu.org/licenses/.           #
#                                                                             #
###############################################################################

from django.conf.urls import url
from . import api


urlpatterns = [
    url(
        r'^$',
        api.SearchView.as_view(),
        name='all'
    ),

    url(
        r'^save/(?P<author_name>\w+)/(?P<name>[\w\-]+)/$',
        api.SearchSaveView.as_view(),
        name='save'
    ),

    url(
        r'^save/$',
        api.SearchSaveView.as_view(),
        name='save'
    ),

    url(
        r'^list/(?P<author_name>\w+)/$',
        api.ListSearchView.as_view(),
        name='list_for_author'
    ),

    url(
        r'^(?P<author_name>\w+)/(?P<object_name>[\w\-]+)/$',
        api.RetrieveDestroySearchAPIView.as_view(),
        name='object'
    ),

    url(
        r'^share/(?P<author_name>\w+)/(?P<object_name>[\w\-]+)/$',
        api.ShareSearchView.as_view(),
        name='share'
    )
]
